package com.ociotec.tmapi.graphql.models;

import java.time.Instant;
import java.util.List;
import java.util.UUID;

import org.eclipse.microprofile.graphql.Description;

import jakarta.validation.constraints.NotNull;
import lombok.Builder;
import lombok.Data;

@Data
@Builder
@Description("Telemetry sample")
public class Sample {

    @NotNull
    @Description("TM sample ID")
    private UUID id;

    @NotNull
    @Description("System of the sample")
    private String system;

    @NotNull
    @Description("Subsystem of the sample")
    private String subsystem;

    @NotNull
    @Description("Telemetry sample name")
    private String name;

    @NotNull
    @Description("Timestamp in UTC")
    private Instant timestamp;

    @NotNull
    @Description("Variant telemetry sample value")
    private Value value;

    @NotNull
    @Description("Sample properties map")
    private List<Property> properties;

}
